  real function psf1 (energy, iband, x1, y1, x0, y0, xcen, ycen, sig, ecut) &
       result (result_psf1)

    real, intent(in) :: x0, y0, xcen, ycen, sig, ecut
    real, dimension(max_ima), intent(in) :: energy
!    real  intent(in) :: ene
    integer, intent(in) :: iband, x1, y1

    real, parameter :: pi = 3.14159265, sec2mm = 7500.0*pi/(180.0*3600.0)
    real(kind=double) :: E, theta, phi, val
    logical :: first = .true.
    integer :: i,ix,iy,ixx,iyy,lx,ly,kx,ky,kk,np,np2,isig3,isig3sq
    integer, dimension(max_ima) :: nx, ny
    type (PsfT) :: ppsf
    type(PsfBinSizeT), dimension(max_ima) :: bsiz
    type(PSFwindowT) :: window
    type(PsfValidityRangesT) :: vrange 
    real(kind=single), dimension(:,:), pointer :: pima
    real, dimension(:,:,:), allocatable :: sima
!!    real, dimension(:,:,:), allocatable ::  psave
    real, dimension(0:100,0:100) :: gengen
    real :: x,y,dx,dy,ddx,ddy,xd0,yd0,xx,yy,x0old,y0old, &
            sum,winr,pfac,xyoff2,ecutold
    real :: sigold = -1.0
    integer :: sxlo,sxhi,sylo,syhi,nlo,nhi,isize

    save

!    determine subimage array sizes (use 2**n sizes for FFT)  
     
     do n=1,8
       isize=2**n
       if (2*ecut < isize) exit
     end do

    xd0=x0-xcen
    yd0=y0-ycen
    xyoff2=(120.0/pixim)**2    

    if (first) then
!!!!!!!test
       write(*,*)  "psf1"
       call fold

!      count_model = 0
      allocate (sima(nim,0:250,0:250))
      nlo=30
      nhi=30
!!      allocate (psave(nim,nlo:nhi,nlo:nhi))
      gengen(0,0) = 1.0
    end if 

    if ((x0-x0old)**2+(y0-y0old)**2>xyoff2.or.ecut/=ecutold.or.first) then

      call CAL_setState1(instrument=EPN, &
                         AccuracyLevel=ACCURACY_MEDIUM)
!      write(*,*) "call CAL EPN"

      theta=sqrt(xd0**2+yd0**2)*pixim
      phi=atan2(xd0,yd0) + pi/2.0

      vrange = CAL_PsfValidityRanges()
      theta = max(min(theta,vrange%thetaMax-1.0),vrange%thetaMin+1.0)

      np = max(0,nint((pixim-1.0)/2.0))
      np2= (2*np+1)**2

      winr = int(ecut)+2.0
      winr = min(winr*pixim,100.0)*sec2mm

      window%halfX = winr
      window%halfY = winr

      do i=1,nim
        E = energy(i)
        E = max(min(E,vrange%eMax-1.0),vrange%eMin+1.0)
        ppsf = Cal_getPSF(E, theta, phi) 
        bsiz(i) = CAL_psfBINSIZE(ppsf) 
        call CAL_psfImage (ppsf, window, pima) 
        nx(i) = size(pima,1)
        ny(i) = size(pima,1)
        do iy=np,ny(i)-1-np 
          do ix=np,nx(i)-1-np
            sum=0.0
            do ixx=ix-np,ix+np
              do iyy=iy-np,iy+np
                sum=sum+pima(ixx,iyy)
              end do
            end do
            sima(i,ix,iy)=sum/np2
          end do
        end do 
        call CAL_releaseMemory(pima)
      end do 

      ecutold=ecut
      first = .false.
!!      psave=-1.

    end if

    x0old=x0
    y0old=y0 


